/*
 * blancoDb Enterprise Edition
 * Copyright (C) 2004-2005 Tosiki Iga
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.db.exception;

import blanco.ig.expander.ClassExpander;
import blanco.ig.expander.Scope;
import blanco.ig.expander.Type;
import blanco.ig.expander.Value;
import blanco.ig.expander.field.FieldExpander;
import blanco.ig.expander.implementor.Statement;
import blanco.ig.expander.method.Constructor;

/**
 * データベースの処理件数が1行ではないことを示す例外クラス <br>
 * このクラスが生成するクラスはblancoDbが生成したソースコードで利用されます <br>
 * 
 * @since 2005.05.12
 * @author IGA Tosiki
 */
public class NotSingleRowExceptionClassDotNet extends ClassExpander {
    /**
     * 例外クラスのクラス名
     */
    public static final String CLASS_NAME = "NotSingleRowException";

    /**
     * コンストラクタに示すJavaDoc説明。
     */
    private static final String CONSTRUCTOR_JAVADOC = "処理件数が期待した1行では無いことを示す例外オブジェクト のインスタンスを作成します。";

    public NotSingleRowExceptionClassDotNet(final Type argType) {
        super(argType);
    }

    protected void expandClassStruct() {
        setSuperClass(new Type("System.Exception"));

        getJavaDoc().addLine("データベースの処理件数が1行ではないことを示す例外クラス");
        getJavaDoc().addLine("このクラスはblancoDbが生成したソースコードで利用されます");
        getJavaDoc().addLine("※このクラスは、ソースコード自動生成後のファイルとして利用されます。");
        getJavaDoc().addLine("");
        getJavaDoc().addLine("@since 2005.12.15");
        getJavaDoc().addLine("@author blanco Framework");

        final FieldExpander fieldCode = new FieldExpander(new Type("string"),
                "SQLSTATE_NOTSINGLEROW") {
            protected Scope getScope() {
                return Scope.PROTECTED;
            }

            protected boolean isStatic() {
                return true;
            }

            protected boolean isFinal() {
                return true;
            }
        };
        fieldCode.getJavaDoc().addLine("このクラスを表現するSQLStateコード。");
        fieldCode.getJavaDoc().addLine(
                "※このクラスを利用する際には、SQLStateには頼らずに例外クラスの型によって状態を判断するようにしてください。");
        fieldCode.setDefaultStatement(new Statement("\"00101\""));
        addField(fieldCode);

        addMethod(new Constructor(CLASS_NAME) {
            public void setupSignature() {
                getJavaDoc().addLine(CONSTRUCTOR_JAVADOC);
                getCgMethod()
                        .setSuperclassInvocation(
                                "base(\"Not single row exception has occured.\" + SQLSTATE_NOTSINGLEROW)");
            }

            public void implement() {
            }
        });

        addMethod(new Constructor(CLASS_NAME) {
            public void setupSignature() {
                getJavaDoc().addLine(CONSTRUCTOR_JAVADOC);
                getJavaDoc().addParameter("reason", "例外の説明");
                addArgument(new Value(new Type("string"), "reason"));
                getCgMethod().setSuperclassInvocation(
                        "base(reason + SQLSTATE_NOTSINGLEROW)");
            }

            public void implement() {
            }
        });

        addMethod(new Constructor(CLASS_NAME) {
            public void setupSignature() {
                getJavaDoc().addLine(CONSTRUCTOR_JAVADOC);
                getJavaDoc().addParameter("reason", "例外の説明");
                addArgument(new Value(new Type("string"), "reason"));
                getJavaDoc().addParameter("SQLState",
                        "例外を識別する XOPENコードまたは SQL 99のコード");
                addArgument(new Value(new Type("string"), "SQLState"));
                getCgMethod()
                        .setSuperclassInvocation("base(reason + SQLState)");
            }

            public void implement() {
            }
        });

        addMethod(new Constructor(CLASS_NAME) {
            public void setupSignature() {
                getJavaDoc().addLine(CONSTRUCTOR_JAVADOC);
                getJavaDoc().addParameter("reason", "例外の説明");
                addArgument(new Value(new Type("string"), "reason"));
                getJavaDoc().addParameter("SQLState",
                        "例外を識別する XOPENコードまたは SQL 99のコード");
                addArgument(new Value(new Type("string"), "SQLState"));
                getJavaDoc().addParameter("vendorCode",
                        "データベースベンダーが定める固有の例外コード");
                addArgument(new Value(new Type("int"), "vendorCode"));
                getCgMethod().setSuperclassInvocation(
                        "base(reason + SQLState + vendorCode)");
            }

            public void implement() {
            }
        });
    }
}